-- Time-stamp: <Sat Jul 26 1997 23:20:28 Stardate: [-31]9694.65 hwloidl>

--@node Tree ADT, , Top, Top
--@chapter Tree ADT

module Tree where

--@menu
--* Imports::			
--* Type::			
--* Basic Fcts::		
--* Instances::			
--@end menu

--@node Imports, Type, Tree ADT, Tree ADT
--@section Imports

#if defined(STRATEGIES)
-- --@include Strategies.lhs
import Strategies
#else

#endif

--@node Type, Basic Fcts, Imports, Tree ADT
--@section Type

#if (__HASKELL1__==4)
data Tree a = Branch a [Tree a] deriving Show
                                         {-!NFData!-}
#else
data Tree a = Branch a [Tree a] deriving Text 
                                         {-!NFData!-}
#endif

--@node Basic Fcts, Instances, Type, Tree ADT
--@section Basic Fcts

repTree :: (NFData a) => (a->[a]) -> (a->[a])-> a -> (Tree a)
repTree f g a = Branch a list
#if 0 && defined(PAR_HO) && defined(STRATEGIES)
                `using` (\ _ -> rnf fa `par` parList rnf list)
#endif
	        where fa = f a 
                      list = map (repTree g f) fa

#if 0
repTree :: (a->[a]) -> (a->[a])-> a -> (Tree a)
repTree f g a = Branch a (par_map 12 (repTree g f) (f a))
#endif

mapTree :: (NFData a, NFData b) => (a -> b) -> (Tree a) -> (Tree b)
mapTree f (Branch a l) = Branch node list 
--#if defined(PAR_HO) && defined(STRATEGIES)
                         `using`  (\ _ -> rnf node `par`
			                  parList rnf list)
--#endif
	                 where node = f a
			       list = map (mapTree f) l

#if 0

mapTree :: (a -> b) -> (Tree a) -> (Tree b)
mapTree f (Branch a l) = parGlobal 14 14 1 0
			   fa
			   (Branch fa (par_map 13 (mapTree f) l))
			 where fa = f a
#endif

-- mapTree :: (a -> b) -> (Tree a) -> (Tree b)
-- mapTree f (Branch a l) = Branch (f a) (map (mapTree f) l)


prune :: (NFData a) => Int -> (Tree a) -> (Tree a)
prune 0 (Branch a l) = Branch a []
prune (n+1) (Branch a l) = Branch a (map (prune n) l)

--@node Instances,  , Basic Fcts, Tree ADT
--@section Instances

{-* DO NOT EDIT BELOW THIS POINT *-}
instance (NFData a) => NFData (Tree a) where{rnf (Branch a b)=rnf a `seq` rnf b}
