-- Time-stamp: <Wed Jun 18 1997 18:40:00 Stardate: [-31]9503.68 hwloidl>
--
-- Alpha-Beta Search
-- Database of winning positions.
--
-----------------------------------------------------------------------------

--@node Win Positions, Making a Move, Board Manipulation, Top
--@chapter Win Positions

module Wins where

--@menu
--* Type::			
--* List of Win Positions::	
--@end menu

board_size :: Int				    
board_size = BOARD_SIZE

--@node Type, List of Win Positions, Win Positions, Win Positions
--@section Type

type Win = [[Int]]

--@node List of Win Positions,  , Type, Win Positions
--@section List of Win Positions

transp :: [[a]] -> [[a]]
transp = foldr 
          (\ xs xss -> zipWith (:) xs (xss++repeat []))
          []
	  	  
wins :: [Win] 
-- wins = [win1,win2,win3,win4,win5,win6,win7,win8]
wins = mk_wins board_size

mk_wins :: Int -> [Win]
mk_wins sz = [ mk_wins_horiz sz n | n <- [1..sz] ] ++
             [ mk_wins_vert sz n | n <- [1..sz] ] ++
             [ mk_wins_diag sz n (+) | n <- [sz+1] ] ++ -- n <- [2,4..2*sz] ] ++ 	  
             [ mk_wins_diag sz n (-) | n <- [0] ]  -- [1-sz..sz-1] ]
	  
mk_wins_horiz :: Int -> Int -> Win
mk_wins_horiz sz n = take (n-1) (repeat (zero_row sz)) ++ 
                     [one_row sz] ++ 
                     take (sz-n) (repeat (zero_row sz))

mk_wins_vert :: Int -> Int -> Win
mk_wins_vert sz n = transp (mk_wins_horiz sz n)

mk_wins_diag :: Int -> Int -> (Int -> Int -> Int) -> Win
mk_wins_diag sz n o = toBoard [ foo r c | r <- [1..sz], c <- [1..sz] ]
                      where foo r c = if r `o` c == n then 1 else 0 
                            toBoard [] = []
                            toBoard xs = take sz xs : toBoard (drop sz xs)
			    

zero_row :: Int -> [Int]
zero_row sz = take sz zeros
              where zeros = repeat 0
one_row :: Int -> [Int]
one_row sz  = take sz ones
              where ones = repeat 1

-- Fixed for sz==3
{-
win1,win2,win3,win4,win5,win6,win7,win8 :: Win 
win1 = [[1,1,1],
        [0,0,0],
        [0,0,0]]
 
win2 = [[0,0,0],
        [1,1,1],
        [0,0,0]]
 
win3 = [[0,0,0],
        [0,0,0],
        [1,1,1]]
 
win4 = [[1,0,0],
        [1,0,0],
        [1,0,0]]
 
win5 = [[0,1,0],
        [0,1,0],
        [0,1,0]]
 
win6 = [[0,0,1],
        [0,0,1],
        [0,0,1]]
 
win7 = [[1,0,0],
        [0,1,0],
        [0,0,1]]
 
win8 = [[0,0,1],
        [0,1,0],
        [1,0,0]]
-}